﻿using Microsoft.AspNetCore.Builder;
using System;

namespace Surging.Core.Swagger.SwaggerUI
{
    public static  class SwaggerUIBuilderExtensions
    {
        public static IApplicationBuilder UseSwaggerUI(
           this IApplicationBuilder app,
           Action<SwaggerUIOptions> setupAction = null)
        {
            if (setupAction == null)
            {
                // Don't pass options so it can be configured/injected via DI container instead
                app.UseMiddleware<SwaggerUIMiddleware>();
            }
            else
            {
                // Configure an options instance here and pass directly to the middleware
                var options = new SwaggerUIOptions();
                setupAction.Invoke(options);

                app.UseMiddleware<SwaggerUIMiddleware>(options);
            }

            return app;
        }
    }
}
